#------------------------ 'operation' Module -------------------------
my @calc_oplist;
&calc_ini;
sub calc_ini{
    @calc_oplist = ({   ""    => \&opDefault, "&"   => \&opAnd,
                        "and" => \&opAnd,     "!"   => \&opNot,
                        "not" => \&opNot,     "-"   => \&opMinus, },
                    {   "|"   => \&opOr,      "or"  => \&opOr, },
                    {   "&&"  => \&opAnd,     "&&&" => \&opAnd, },);
    my @op = ('(', ')', '{', '}', '"');
    my $ptr;
    for $ptr (@calc_oplist){
        my $op;
        for $op (keys %$ptr){
            push(@op, quotemeta($op)) if length $op;
        }
    }
    $OpPattern = '^(' . join('|', @op) . ')$';
}

sub calc_sub{
    my $p = shift;
    my $lvl = shift;
    my $a = shift;
    my @olist = ();

    while (@_){
        my $op = '';
        my $b = shift;
        $op = $b, $b = shift unless ref $b;
        if (defined($lvl->{$op})){
            &{$lvl->{$op}}($a, $b, $p, (@_ && ref $_[0]));
        }else{
            push(@olist, $a);
            push(@olist, $op);
            $a = $b;
        }
    }
    push(@olist, $a);
    @olist;
}

sub calcp{
    # ̤Ȥ׻롣
    # ˤϡ̤ΤʤꥹȤϤ
    my($p, @list) = @_;
    my($a, $b);

    for $lvl (@calc_oplist){
        @list = &calc_sub(($p eq '{'), $lvl, @list);
    }
    return $list[0];
}

sub operate_proc{
    my($p, $calc, @list) = @_;
    my($l, $r);
    my($lp, $rp) = $p? ('[\{\(]', '[\}\)]'): ('[\(]', '[\)]');

    for (;;){
        my @x = ();
        my @y = ();
        my $tmp;

        while (@list){
            last if ($tmp = shift @list) =~ /^$rp$/;
            push(@x, $tmp);
            $tmp = '';
        }
        return &$calc('(', @x) unless $tmp;

        while (@x){
            last if ($tmp = pop @x) =~ /^$lp$/;
            unshift(@y, $tmp);
        }
        @list = (@x, &$calc($tmp, @y), @list);
    }
}

sub operate{
    my(@arg) = @_;
    my($arg, @list);

    foreach $arg (@arg){
        if ($arg =~ /^(not|\!)$/){
            push(@list, 'not');
        }elsif ($arg =~ /^(\-)$/){
            push(@list, '-');
        }elsif ($arg =~ /^(or|\|)$/){
            push(@list, 'or');
        }elsif ($arg =~ /^(and|\&)$/){
            push(@list, 'and');
        }elsif ($arg =~ /^(\&\&|\&\&\&)$/){
            push(@list, '&&');
        }elsif ($arg =~ /^[\(\)\{\}]$/){
            push(@list, $arg);
        }else{
            push(@list, shift(@ScorePtr));
        }
    }
    &operate_proc(1, \&calcp, @list);
}
1;
#--------------------- End of 'operation' Module ---------------------
