#!/usr/local/bin/perl5
# linmz.pl - by furukawa@tcp-ip.or.jp

for $argv (@ARGV){
    my ($db, $ext) = ($argv =~ /^(.*NMZ)(\.[^\/\\]+)$/);
    my $add = ($ext =~ /^\.field\./)? ".i": "i";

    $IntNType = 'I';
    $IntNType = 'V' if -e "$db.le";
    $IntNType = 'N' if -e "$db.be";
    $IntNType = 'N' unless -e "$db.h";

    if (open(FI, $argv)){
        binmode(FI);
        if (open(FO, ">$argv$add")){
            binmode(FO);
            $offset = 0;
            while (<FI>){
                print FO pack($IntNType, $offset) if /^[^#\r\n]/;
                $offset += length($_);
            }
            print FO pack($IntNType, $offset);
            close(FO);
        }
        close(FI);
    }
}
