#!/usr/local/bin/perl5

$SCRIPT_NAME = '';
## cgiwrap Τˡּ xx פɽǤʤȤˡ
## CGI ХѥꤷƲ
## 㤨Сhttp://www.xxx.yyy/zzz/namazu.cgi ä
##  $SCRIPT_NAME = '/zzz/namazu.cgi';
## Τ褦

# pnamazu-2006.12.23
# Namazu Search (perl ) by furukawa@tcp-ip.or.jp

{
    my($tmp) = $0;

    $tmp = "./$tmp" if -e $tmp && $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}

$Debug = 1 if -e "debug";

sub config{
    $Pnamazu = '2006.12.23';
    $Author = 'furukawa@tcp-ip.or.jp';
    require 'pconfig.pl';
    if (!$ScriptFileName){
        $ScriptFileName = $0;
        if (-f $ENV{'SCRIPT_FILENAME'}){
            $ScriptFileName = $ENV{'SCRIPT_FILENAME'};
        }
    }
    &debug_log("config: SCRIPT_FILENAME=$ScriptFileName");
    ($ScriptDir = $ScriptFileName) =~ s/[\\\/].*?$// if $ScriptFileName && !$ScriptDir;

    if ($SCRIPT_NAME eq ''){
        if (($SCRIPT_NAME = $ENV{'SCRIPT_NAME'}) =~ /cgiwrap/i){
            if (length $ENV{'REQUEST_URI'}){
                ($SCRIPT_NAME = $ENV{'REQUEST_URI'}) =~ s/\?.*$//;
            }
            $Warn_Scriptname = 1 if $SCRIPT_NAME =~ /cgiwrap/i;
        }
    }
    &debug_log("config: SCRIPT_NAME=$SCRIPT_NAME");
}

require 'ldnmzcnf.pl';
require 'cmdline.pl';
require 'iocode.pl';
require 'output.pl';
require 'plain.pl';
my @caller = caller;
&premain;

require 'inttype.pl';
require 'wsearch.pl';
require 'hashop.pl';
require 'operate.pl';
require 'input.pl';
require 'db.pl';
require 'bw.pl';
require 'mb.pl';
require 'sb.pl';
require 'reg.pl';
require 'phrase.pl';
require 'field.pl';
require 'regconv.pl';
require 'tsearch.pl';
require 'cache.pl';
require 'summary.pl';
require 'format.pl';

#--------------------------- 'main' Module ---------------------------
sub set_nkf{
    if ($Use_Nkf && !defined($Nkf_enable)){
        $Nkf_enable = 0;
        eval "use NKF;";
        if ($@){
            &debug_log("NKF.pm disable($@)\n");
        }elsif (!defined($NKF::VERSION)){
            &debug_log("NKF.pm disable (NKF::VERSION is not found)\n");
        }elsif ($NKF::VERSION < 2.04){
            &debug_log("NKF.pm disable (version: $NKF::VERSION is too old)\n");
        }else{
            &debug_log("NKF.pm enable (version: $NKF::VERSION)\n");
            $Nkf_enable = 1;
        }
    }
}

sub cgiparamget{
    # CGI  QUERY_STRING ɤ
    my ($val, $key, $tmp);

    if ($PathInfo = $ENV{'PATH_INFO'}){
        my $scr = $ENV{'SCRIPT_NAME'};
        if (substr($PathInfo, 0, length $scr) eq $scr){
            $PathInfo = substr($PathInfo, length $scr);
        }
        ($val = $PathInfo) =~ s/^\///;
        push(@DbList, $val) if length $val;
    }

    $val = $ENV{'QUERY_STRING'};
    $val = join('', <>) if !$val && $ENV{'REQUEST_METHOD'} =~ /post/i;
    $QueryLength = length $val;

    @OriginalQuery = split(/&/, $val);
    for $tmp (@OriginalQuery){
        ($key, $val) = split(/=/, $tmp);
        $val =~ s/\+/ /g;
        $val =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C",hex($1))/eg;

        if ($key =~ /^(key|query)$/i){
            if ($Phone){
                $ARGV = &shiftjis_to_euc($val, 'a2a', 'k2e');
            }else{
                $ARGV = &str2euc($val, 'a2a');
            }
            $KeyStr = &metach($ARGV);
        }
        if ($key =~ /^sort$/i){
            $Sort = $val;
            $SortField = ($Sort =~ /^\+?(field|fstat):([^:]+)/)? $2: '';
            $Sort =~ s/[^a-z\d_:]+//gi;
        }
        $Max = $val if $key =~ /^max$/i && $val =~ /^\d+$/;
        $Whence = $val if $key =~ /^whence$/i && $val =~ /^\d+$/;
        @DbList = (@DbList, split(/,/, $val)) if $key =~ /^(idx|db)name$/i && $val !~ /^\// && $val !~ /\.\.\// && $val !~ /[\"\<\|\>\;\\]/;

        if ($tmp =~ /format/i && $val =~ /^[A-Z][A-Z0-9_\-]*$/i){
            $Result = $Format if ($Format = $val) eq 'short';
        }
        if ($tmp =~ /result/i && $val =~ /^[A-Z][A-Z0-9_\-]*$/i){
            $Format = $Result if ($Result = $val) eq 'short';
        }
        $Subquery = &metach(&str2euc($val, 'a2a')) if $key =~ /^subquery/i;
        $val =~ s/[\"\'\&\<\|\>\;\\]+//g;
        $Detail= $val if $tmp =~ /detail/i;
        $Reference = $val if $key =~ /^references?$/i;
        $BaseDir = $val if $key =~ /^basedir$/i;
        $GrepMode = $val if $key =~ /^grep$/i;
        $CmdLang = $val if $key =~ /^lang$/i;
        $OpMode = $val if $key =~ /^opmode$/i;
        $Lucky = 1 if $key =~ /^submit$/i && $val =~ /$Jump/i;
    }
    $ARGV =~ s/\s\&\&\&+\s/ \&\& /g;
    $Subquery =~ s/\s\&\&\&+\s/ \&\& /g;
    if ($Subquery){
        if (length $ARGV){
            $ARGV = "$Subquery &&& $ARGV";
        }else{
            $ARGV = "$Subquery &&&";
        }
    }
    $Max = 10, $Result = 'phone' if $Phone;
}

sub pre_proc{
    $ARGV = &string_normalize($ARGV);
    @ARGV = split(/\s+/, $ARGV);

    &opendb();
    &set_inttype;
}

sub searchmain{
    local(*score);
    my($no, $key, $tmp);

    if ($TinyMknmz){
        # tiny_mknmz ˤ륤ǥåк
        my @tmp = ();
        my $tmp;
        for $tmp (split(/\s+/, $ARGV)){
            push(@tmp, $tmp), next if $tmp =~ /^[\/\+]|$OpPattern/oi;

            if ($tmp =~ /[\xa1-\xfe]/){
                # tiny_mknmz Ǥϴ 1 ʸŤϿ
                # Τǡʬפϰ̣ʤ
                $tmp =~ s/^\*([\xb0-\xfe])/$1/;
                $tmp =~ s/([\xb0-\xfe].)\*$/$1/;
                push(@tmp, $tmp);
                next;
            }

            # tiny_mknmz ǤϵޤϿƤʤΤǡ
            # äʬ䤷Ƥ
            my $fw = ($tmp =~ s/^([\\\*])([a-zA-Z\d_])/$2/)? $1: '';
            my $bw = ($tmp =~ s/^([a-zA-Z\d_]+)(\*)$/$1/)? $2: '';
            my @ary;

            $tmp =~ s/^[^a-zA-Z\d_]+//;
            $tmp =~ s/[^a-zA-Z\d_]+$//;

            while ($tmp =~ s/^([a-zA-Z\d_]+([\-\/\.\=\'][a-zA-Z\d_]+)*)//){
                push(@ary, $1);
                $tmp =~ s/^[^a-zA-Z\d_]+//;
            }

            $ary[0] = "$fw$ary[0]";
            $ary[$#ary] .= $bw;

            push(@tmp, '(') if @ary > 1;
            my $elem;
            for $elem (@ary){
                my @ph = split(/[\-\/\.\=\']/, $elem);
                push(@tmp, '{') if @ph > 1;
                @tmp = (@tmp, @ph);
                push(@tmp, '}') if @ph > 1;
            }
            push(@tmp, ')') if @ary > 1;
        }
        $ARGV = join(" ", @tmp);
        &debug_log("TinyMknmz: $ARGV");
    }

    # ñ򤽤줾측
    if ($KPMode){
        my @tmp = split(/\s+/, $ARGV);
        @ARGV = ();
        for $tmp (@tmp){
            if ($tmp =~ /^((\xa1\xbc|\xa5.)+\xa1\xa6)+(\xa1\xbc|\xa5.)+$/){
                my $opmode = 0;
                $RespTextOrig = 1;

                my @spl = ();
                push(@spl, $1) while $tmp =~ s/^((\xa1\xbc|\xa5.)+)\xa1\xa6//;
                push(@spl, $tmp);

                if ($OpMode eq 'inside' || $OpMode eq 'forward'){
                    $opmode = 1;
                    $spl[$#spl] = "$spl[$#spl]*";
                    $spl[0] = "*$spl[0]" if $tmp = ($OpMode eq 'inside')? 1: 0;

                    @ARGV = (@ARGV, '(', join('', @spl));

                    $spl[$tmp++] = "\\$spl[$tmp]" while $tmp < $#spl;
                }else{
                    @ARGV = (@ARGV, '(', join('', @spl));
                }
                @ARGV = (@ARGV, 'or', '{');

                my $dot = "\xa1\xa6";
                $dot = "\\$dot" if $opmode;
                while (@spl){
                    $tmp = shift(@spl);
                    push(@ARGV, $tmp);
                    push(@ARGV, $dot) if @spl;
                }
                push(@ARGV, '}');
                push(@ARGV, ')');
            }else{
                push(@ARGV, $tmp);
            }
        }
    }else{
        @ARGV = split(/\s+/, $ARGV);
    }
    $ARGV = &searchwords(@ARGV);
    @ARGV = split(/\s+/, $ARGV);

    # 黻
    %score = %{&operate(@ARGV)};
    my $dis = $score{'Disable'};
    my $too = $score{'TooMany'};
    delete $score{'Disable'};
    delete $score{'TooMany'};
    delete $score{'phrase'};
    delete $score{'field_l'};
    delete $score{'field_r'};

    $Keys = scalar(keys(%score));
    return if $dis || $too;
    for $tmp (keys(%score)){
        $key = $tmp;
        $key .= "#$DbPath";
        $Score{$key} = $score{$tmp};
    }
}

sub compare{
    my ($x, $y) = @_;
    return ($x <=> $y) if $x =~ /^[\d\s]+$/ && $y =~ /^[\d\s]+$/;
    $x cmp $y;
}

sub searchsort{
    # ̤Υ

    if ($Sort =~ /^(field|fstat):.+:descending/){
        @Keys = sort {&compare($SElem{$b}, $SElem{$a})
                        or $Tim{$b} <=> $Tim{$a} 
                          or $Score{$b} <=> $Score{$a}} keys(%Score);
    }elsif ($Sort =~ /^(field|fstat):.+(:ascending)?/){
        @Keys = sort {&compare($SElem{$a}, $SElem{$b})
                        or $Tim{$b} <=> $Tim{$a} 
                          or $Score{$b} <=> $Score{$a}} keys(%Score);
    }elsif ($Sort eq 'earlier' or $Sort eq 'date:early'){
        @Keys = sort {$Tim{$a} <=> $Tim{$b}
                        or $Score{$b} <=> $score{$a}} keys(%Score);
    }elsif ($Sort eq 'nosort'){
        @Keys = keys(%Score);
    }elsif ($Sort eq 'score'){
        @Keys = sort {$Score{$b} <=> $Score{$a}
                      or $Tim{$b} <=> $Tim{$a}} keys(%Score);
    }elsif ($Sort =~ /^\+(field|fstat):/){
        my $key;
        for $key (keys %Score){
            $Score{$key} = 1 if $Score{$key} < 1;
            $Score{$key} = int($Score{$key} + $SElem{$key});
            $Score{$key} = 1 unless $Score{$key};
        }
        @Keys = sort {$Score{$b} <=> $Score{$a}
                      or $Tim{$b} <=> $Tim{$a}} keys(%Score);
    }else{
        @Keys = sort {$Tim{$b} <=> $Tim{$a}
                      or $Score{$b} <=> $score{$a}} keys(%Score);
    }
    $Keys = scalar(@Keys);

    if ($Lucky){
        my ($keyno, $keydb);
        $keyno = $Keys[0], $keydb = ''
            unless ($keyno, $keydb) = split(/\#/, $Keys[0]);
        if (&openbfile('URI', "$keydb.field.uri")
            && &openbfile('URIINDEX', "$keydb.field.uri.i")){
            $LuckyURI = &getsdb('URI', &indexpointer('URIINDEX', $keyno));
            &replace($LuckyURI);
        }
    }
}

sub tag_elem{
    my ($str, $key, $val) = @_;

    if (defined $val){
        $str =~ s/($key\s*\=\s*\")([^\"]*)(\")/$1$val$3/i
            || $str =~ s/($key\s*\=\s*)(\S*)/$1$val/i
                || $str =~ s/\s*\>/ $key=\"$val\"\>/; #"
        return $str;
    }else{
        $val = $2 if $str =~ /($key\s*\=\s*\")(.*?)(\")/i || $str =~ /($key\s*\=\s*)(\S*)/i; #"
        return $val;
    }
}

sub tag_sel{
    my($str, $key, $val) = @_;
    if ($val){
        $str =~ s/\s*\/\>/ $key=\"$key\" \/\>/
            || $str =~ s/\s*\>/ $key\>/ if $str !~ /$key/i;
    }else{
        $str =~ s/$key=\"$key\"// || $str =~ s/\s*$key//i;
    }
    $str;
}


sub headcat{
    if (@_ && shift){
        # Phone mode
        &output("<html><head>\n");
        &lang_exp;
        &output("</head>\n<body>\n");
        return;
    }
    # NMZ.head ν
    my($name, $form, $val);
    my($pre, $post);
    my($tag, $value);
    my($ptr, $select);
    my(@db) = @DbList;

    local(%paramtbl) = ('max' => \$Max,
                        'sort' => \$Sort,
                        'format' => \$Format,
                        'detail' => \$Detail,
                        'idxname' => \@DbList,
                        'dbname' => \@DbList,
                        'subquery' => \$Subquery,
                        'reference' => \$Reference,
                        'basedir' => \$BaseDir,
                        'grep' => \$GrepMode,
                        'cgi' => \$CmdLang,
                        'result' => \$Result,
                        'opmode' => \$OpMode,
                        'lang' => \$CmdLang,
                        );
    my($head_grep) = 1;
    my($head_opmode) = 1;
    my($intitle, $incomment, $line);
    foreach $line (@HEAD){
        while ($line ne ''){
            if ($incomment){
                if ($line =~ s/^(.*?\-\-\>)//){
                    &output($1);
                    $incomment = 0;
                    next;
                }else{
                    &output($line);
                    last;
                }
            }elsif ($intitle){
                if ($line =~ s/^(.*?\<\/title[^>]*>)//i){
                    $_ .= $1;
                    $intitle = 0;
                }else{
                    $_ .= $line;
                    last;
                }
            }else{
                if ($line =~ s/^(.*?)(\<(\!\-\-|title))/$1 eq ''? '': $2/ie){
                    if ($1 eq ''){
                        if ($2 eq '<!--'){
                            &output($2);
                            $incomment = 1;
                        }else{
                            $_ = $2;
                            $intitle = 1;
                        }
                        next;
                    }else{
                        $_ = $1;
                    }
                }else{
                    $_ = $line;
                    $line = '';
                }
            }
            &output($_), next if /^\s*\<\!\-\-.*\-\-\>\s*$/;
            s/\{cgi\}/$SCRIPT_NAME/g if length $SCRIPT_NAME;

            s/(\<title[^\>]*\>)(.*)(<\/title)/$1 . &format_title($2) . $3/eis;
            if (/\<(\/head|title)/i && &get_language eq 'ja' && !$ExistMeta){
                $ExistMeta = 1;
                &lang_exp;
            }
            if (/\<\/HEAD\>/i){
                &meta_http_equiv("Last-Modified", $LastModified);
                &output("<base href=\"$BASE_URL\">\n") if $BASE_URL;
            }
            &output($_), next if !$QueryLength && $PrintForm;

            $form = 1 if /\<FORM/i;
            if ($PrintForm || !$form){
                if (/^(.*)(\<\s*(option|select|input|\/select).*?\>)(.*\n?)$/i){
                    $pre = $1;
                    $post = $4;
                    $_ = $2;
                    ($tag = $3) =~ tr/A-Z/a-z/;

                    $name = &tag_elem($_, 'name');
                    $name =~ tr/A-Z/a-z/;
                    $value = &tag_elem($_, 'value');

                    if ($name =~ /^(idx|db)name/){
                        @db = grep {$_ ne $value} @db;
                    }
                    if ($tag eq 'input'){
                        my($type) = &tag_elem($_, 'type');
                        $type =~ tr/A-Z/a-z/;
                        if ($type eq 'text' and $name eq 'key' || $name eq 'query'){
                            if ($RespTextOrig){
                                $_ = &tag_elem($_, 'value', $KeyStr);
                            }else{
                                my $tmp = $ARGV;
                                if ($Subquery){
                                    $tmp =~ s/^.*\s*\&\&\&\s*//;
                                    $tmp =~ s/^\(\s*(.*)\s*\)\s*$/$1/;
                                }
                                $tmp = &metach($tmp);
                                my @tmp = split(/\s+/, $tmp);
                                if (@tmp = &reducep(@tmp)){
                                    $_ = &tag_elem($_, 'value', join(' ', @tmp));
                                }
                            }
                        }elsif ($type eq 'checkbox'){
                            if ($name =~ /^(db|idx)name/i){
                                $_ = &tag_sel($_, 'checked',
                                              grep($value eq $_, @DbList));
                            }elsif ($name eq 'grep'){
                                $head_grep = 0;
                                $_ = &tag_sel($_, 'checked', $GrepMode eq 'on');
                            }
                        }
                    }elsif ($tag eq 'select'){
                        $ptr = $paramtbl{$name};
                        $select = (ref($ptr) ne 'SCALAR');
                        $head_grep = 0 if $name eq 'grep';
                        $head_opmode = 0 if $name eq 'opmode';
                    }elsif ($tag eq '/select'){
                        if (!$select && ($ptr = $$ptr) ne ''){
                            &output("<option value=\"$ptr\" selected>$ptr\n");
                        }
                    }elsif ($tag eq 'option'){
                        my($flag);
                        # sort, format, max  VALUE 

                        if (ref($ptr) eq 'ARRAY'){
                            $select = 1 if $flag = grep($value eq $_, @$ptr);
                            $_ = &tag_sel($_, 'selected', $flag);
                        }elsif (ref($ptr) eq 'SCALAR'){
                            $select = 1 if $flag = ($$ptr =~ /^$value$/i);
                            $_ = &tag_sel($_, 'selected', $flag);
                        }
                    }
                    $_ = "$pre$_$post";
                }
                if (/\<\/FORM\>/i){
                    if (@db){
                        my $db;
                        for $db (@db){
                            my $str = "dbname";
                            &output("<input type=\"hidden\" name=\"$str\" value=\"$db\">\n") if defined $db;
                        }
                    }
                    &output("<input type=\"hidden\" name=\"grep\" value=\"$GrepMode\">\n") if $head_grep && $GrepMode;
                    &output("<input type=\"hidden\" name=\"opmode\" value=\"$OpMode\">\n") if $head_opmode && $OpMode;
                }
                &output($_);
            }
            $form = 0 if /\<\/FORM\>/i;
        }
    }
    &disp_debug;
}

sub disp_error{
    if (@DbErrors){
        my $str;
        &output("Errors:\n");
        for $str (@DbErrors){
            &message("$str<BR>\n");
        }
    }
    &disp_debug;
}

sub debug_log{
    if ($Debug >= 0){
        push(@Debug, shift);
        &disp_debug if $^P;
    }
}

sub disp_debug{
    if ($Debug > 0){
        &message("Debug: " . &metach(shift(@Debug)) . "<BR>\n") while @Debug;
    }
}

sub metach{
    my $s = shift;
    $s =~ s/\&/\&amp\;/g;
    $s =~ s/\</\&lt\;/g;
    $s =~ s/\>/\&gt\;/g;
    $s =~ s/\"/\&quot\;/g; #"
    return $s;
}

sub quote_meta{
    my $s = shift;
    $s =~ s/([\x00-\x7f]+)/quotemeta($1)/ge;
    return $s;
}

sub calc_slist{
    return if $Phone or $Format eq 'veryshort' && !$Cgi;
    my($dblist) = @_;
    my($detail) = ($Detail ne 'off');
    my $ndx = -1;
    my $ss = '';
    if (@Words){
        @SWord = sort {length($b) <=> length($a)} @SWord;
        grep {$_ = &quote_meta(&metach($_));
              s/^(\w)/\\b$1/,
              s/(\w)$/$1\\b/ unless s/([\xa1-\xfe].)/\xff$1/g} @SWord;
        if (!$Quiet){
            $ss .= "<li><strong>" . &metach("$dblist: $Keys") . "</strong>: " if $dblist;
            $ss .= "<ul>\n" if $detail;
            my $word;
            for $word (@Words){
                next if ++$ndx < $SubQueryWords;
                $ss .= "<li>\n" if $detail;
                my $tmpw = substr($word, ord($word) == ord("\\"));

                if ($SubHit{$word} && $detail){
                    $ss .= &metach(" [ $tmpw: $Hit{$word} \(");
                    $ss .= "<ul>\n";

                    my @Keys = sort {$b <=> $a} keys %{$SubHit{$word}};
                    my $key;
                    foreach $key (@Keys){
                        my $tmp = join(" ", sort keys %{$SubHit{$word}->{$key}});
                        $ss .= "<li>" . &metach("$key= $tmp ") . "</li>\n";
                    }
                    $ss .= "</ul>\n\)] \n";
                }else{
                    $ss .= &metach(" [ $tmpw: $Hit{$word} ] ");
                }
                $ss .= "</li>\n" if $detail;
            }
            $ss .= "</ul>" if $detail;
            $ss .= "</li>" if $dblist;
            $ss .= "\n";
        }
    }
    $SList .= $ss;
    $Sword{$DbPath} = join('|', @SWord);

    if (@DbErrors){
        $SList .= "Errors:\n";
        $SList .= &metach(shift @DbErrors) . "<BR>\n" while @DbErrors;
    }
}

sub conv_result{
    my ($keyno, $keydb, $ndx, $score, $str) = @_;
    my $dbpath = $keydb? $keydb: $DbPath;

    if ($str eq 'namazu::accesskey'){
        $ndx -= $Whence;
        $ndx = '' if $ndx > 10;
        $ndx = '0' if $ndx == 10;
        &debug_log("result: $str => $ndx");
        return $ndx;
    }
    &debug_log("result: $str => $ndx"), return $ndx if $str eq 'namazu::counter';
    &debug_log("result: $str => $score"), return $score if $str eq 'namazu::score';
    &debug_log("result: $str => $ARGV"), return $ARGV if $str eq 'namazu::query';
    &debug_log("result: $str => $Db2IdxDir{$keydb}"), return $Db2IdxDir{$keydb} if $str eq 'namazu::idxdir';
    &debug_log("result: $str => $Db2IdxName{$keydb}"), return $Db2IdxName{$keydb} if $str eq 'namazu::idxname';
    &debug_log("result: $str => $keyno"), return $keyno if $str eq 'namazu::docid';
    $str =~ s/(\:.*)$//;
    my $opt = $1;
    unless($DbSize{"RFI$str.$keydb"}){
        &openbfile("RF_$str.$keydb", "$dbpath.field.$str");
        &openbfile("RFI$str.$keydb", "$dbpath.field.$str.i");
        if (!$DbSize{"RFI$str.$keydb"} && $FieldAlias{$str}){
            &openbfile("RF_$str.$keydb", "$dbpath.field.$FieldAlias{$str}");
            &openbfile("RFI$str.$keydb", "$dbpath.field.$FieldAlias{$str}.i");
        }
    }
    my $buf;
    if ($DbSize{"RFI$str.$keydb"}){
        $buf = &getsdb("RF_$str.$keydb", &indexpointer("RFI$str.$keydb", $keyno));
        chomp $buf;
        if ($str eq 'summary'){
            &debug_log("result: $str");
        }else{
            &debug_log("result: $str => $buf");
        }
    }

    if ($buf !~ /^(([\xa1-\xfe]{2}|[\s\x20-\x7e])*)$/){
        $buf =~ tr/\xa0/\xa1/;
        $buf =~ s/^(([\xa1-\xfe]{2}|[\s\x20-\x7e])*)[\xa1-\xfe]$/$1/;
        &debug_log("warning(nkf1.9): $buf");
    }

    if ($str eq 'uri'){
        &replace($buf);
        $buf = metach($buf);
        if ($opt =~ /::decode/){
            $buf =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C",hex($1))/eg;
            $buf = &str2euc($buf);
        }
    }elsif ($str eq 'summary'){
        my $sizelimit = -1;
        if ($opt =~ /::size=(\d+)/){
            $buf = substr($buf, 0, $sizelimit = $1);
            $buf =~ /^(([\xa1-\xfe][\xa1-\xfe]|[^\xa1-\xfe])*)/;
            $buf = $1;
        }
        if (!$PlainConv){
            $buf = metach($buf);
            $buf =~ s/([\xa1-\xfe].)/\xff$1/g;
            $buf =~ s/($Sword{$keydb})/$EmTagS$1$EmTagE/gi if length $Sword{$keydb};
            $buf =~ tr/\xff//d;
        }
        if ($SUMMARY && $DbSize{"RLISTINDEX$keydb"}){
            my ($dt, $st, $summary, $dd, $grep);

            if ($buf eq ''){
                ($dt, $st, $summary, $dd, $grep)
                    = &make_summary($keydb, $keyno, "s$MakeGrep", $sizelimit);
                $buf = $summary;
            }elsif ($MakeGrep){
                $grep = &make_summary($keydb, $keyno, 'g');
            }
            if (length $grep){
                if ($GrepFirst){
                    $buf = "$grep$buf<br$Xht>\n";
                }else{
                    $buf .= "<br$Xht>\n$grep";
                }
            }
        }
    }else{
        $buf = metach($buf) unless $opt =~ /::noescape/;
        if ($str eq 'title' and !$PlainConv){
            $buf =~ s/([\xa1-\xfe].)/\xff$1/g;
            $buf =~ s/($Sword{$keydb})/$EmTagS$1$EmTagE/gi if length $Sword{$keydb};
            $buf =~ tr/\xff//d;
        }
    }
    $buf;
}

sub puthlist{
    if ($CountOnly){
        &prn($Keys . "\n");
        exit;
    }

    # ̽
    if ($Keys){
        &output("<dl>\n") if $Cgi || $Format ne 'veryshort' and !$Quiet;

        foreach $key (@Keys){
            last if ($Whence + $Max) <= $Ndx && $Max;

            my($offset, $next, $summary, $dt, $st, $dd, $grep);
            $keyno = $key, $keydb = ''
                unless ($keyno, $keydb) = split(/\#/, $key);
            ++$Ndx;

            $IntType = $DbIntType{$keydb};
            $IntNType = $DbIntNType{$keydb};
            $IntSize = $DbIntSize{$keydb};
            $DbVer2 = $DbVer2{$keydb};

            if($Whence < $Ndx){
                &disp_debug;
                &debug_log("sortfield: $SElem{$key}");
                &debug_log("list: t => " . localtime($Tim{$key}));
                unless (defined $DbSize{"RESULT$keydb"}){
                    $DbSize{"RESULT$keydb"} = 0;
                    my $dbpath = $keydb? $keydb: $DbPath;
                    my @result = ("", ".normal");
                    my $result;
                    unshift(@result, ".$Result") if length $Result;
                    for $result (@result){
                        last if &opentfile("RESULT$keydb",
                                              "$dbpath.result$result");
                        last if &opentfile("RESULT$keydb",
                                              "$Headname.result$result");
                    }
                }
                if ($DbSize{"RESULT$keydb"} && $DbVer2){
                    unless ($Cgi || $Format ne 'veryshort'){
                        &output(&conv_result($keyno, $keydb, $Ndx, $Score{$key}, "uri") . "\n");
                        next;
                    }

                    my $line;
                    &output("\n");
                    while (($offset, $line) = &getsdb("RESULT$keydb", $offset)){
                        last unless length $line;
                        $line = &str2euc($line);
                        $line =~ s/\$\{(.*?)\}/&conv_result($keyno, $keydb, $Ndx, $Score{$key}, $1)/ge;
                        &output($line . "\n");
                    }
                    &output("\n");
                    next;
                }
                if ($DbSize{"FLISTINDEX$keydb"}){
                    $offset = &indexpointer("FLISTINDEX$keydb", $keyno);
                    $next = &lastSize("FLIST_____$keydb",
                                      $keyno + 1, "FLISTINDEX$keydb");

                    ($dt, $st, $summary, $dd) =
                        split(/\n/,
                              &readdb("FLIST_____$keydb",
                                      $offset, $next - $offset),
                              4);
                    if ($SUMMARY && $MakeGrep && $DbSize{"RLISTINDEX$keydb"}){
                        $grep = &make_summary($keydb, $keyno, 'g');
                    }
                }elsif ($SUMMARY
                        and $MakeSummary || $MakeGrep
                        and $DbSize{"RLISTINDEX$keydb"}){
                    ($dt, $st, $summary, $dd, $grep) = &make_summary($keydb, $keyno, "f$MakeGrep");
                }
                &replace($st);
                &replace($dd);
                if ($Format ne 'veryshort'){
                    &output("$dt$Ndx. $st (score: $Score{$key})\n");
                }
                if ($Format eq 'long'){
                    if (!$PlainConv){
                        $summary =~ s/\e\$.(.*?)\e\(./{my $tmp = $1;
                                                       $tmp =~ tr\/\x21-\x7e\/\xa1-\xfe\/;
                                                       $tmp}/ge;
                        $summary =~ s/([\xa1-\xfe].)/\xff$1/g;
                        $summary =~ s/($Sword{$keydb})/$EmTagS$1$EmTagE/gio if length $Sword{$keydb};
                        $summary =~ tr/\xff//d;
                    }
                    &output("$summary<br$Xht>\n$grep\n");
                }
                if ($DecodeURL){
                    $dd =~ s/(\<a href=\")(.*?)(\")/$1.&decode_url($2).$3/ei; #"
                }elsif ($SplitLink){
                    $dd =~ s/\<a href=\"(.*?)\"[^<]+<\/A>/&splitlink($1)/ei; #"
                }
                $dd =~ s/\n+/\n/g, $dd =~ s/ size \(\d.*$//g if $Format eq 'veryshort';
                &output($dd);
            }
        }
        &disp_debug;
        &output("</dl>\n") if $Cgi || $Format ne 'veryshort';
    }elsif (!$Phone){
        if (&opentfile(*FH, "$DbPath.tips") || &openfiles(*FH, 'tips')){
            &message(<FH>);
            close(FH);
        }
    }
}

sub splitlink{
    local($_) = @_;
    my($pre, $path, $ret);
    my(@elem, @link);

    if (s/^([a-zA-Z]+\:\/\/[^\/]*)//){
        $pre = $1;
    }

    @elem = split(/\//, $_);
    $elem[0] .= $pre;

    while (defined($_ = shift(@elem))){
        $_ .= '/' if scalar(@elem);
        $path .= $_;
        $ret .= "<a href=\"$path\">$_</a>";
    }
    $ret;
}

sub putpagelink{
    my($num, $str, $akey) = @_;
    my $href = &pagehref($num/$Max, $akey);
    &output($href. "[$str]</a>");
}

sub putpageindex{
    if ($Max){
        my($PAGE_MAX, $num, $i) = (0, 0, 0);

        if ($Warn_Scriptname){
            &output($Text{'cgiwrap'});
            return;
        }

        &output("<strong>Page:</strong>\n") if $Keys && !$Phone;

        if ($Keys > $Whence){
            if ($Max && ($Whence >= $Max) && !$Phone){
                &putpagelink($Whence - $Max, "prev");
            }
            while ((!$PAGE_MAX || $i < $PAGE_MAX) && $num < $Keys){
                $i++;
                if (!$Phone){
                    if ($num == $Whence){
                        &output("<strong>[$i]</strong>");
                    }else{
                        &putpagelink($num, $i);
                    }
                }
                $num += $Max;
                &output("\n");
            }
            if ($Whence + $Max  < $Keys){
                &putpagelink($Whence + $Max, "next", "\#");
            }
        }
    }
}

sub puthtmlheader{
    $| = 1;
    if ($Cgi && !$PutHead){
        $PutHead = 1;
        &prn("Last-Modified: $LastModified\n") if $LastModified;
        &prn("Content-Type: text/html");
        &prn("; charset=" . &get_output_ja_code) if &get_language eq 'ja';
        &prn("\n\n");
    }
    open(STDERR, ">&STDOUT") if $Debug > 0;
    &disp_debug;
}

sub slog{
    my($rhost);
    local(*SLOG);
    $rhost = ($ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'});
    if (open(SLOG, ">>$DbPath.slog")){
        my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time);
        printf SLOG ("%s\t%d\t%s\t%s %s %2d %02d:%02d:%02d %4d\n", 
                     $ARGV, $Keys, $rhost,
                     ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$wday],
                     ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                      'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$mon],
                     $mday, $hour, $min, $sec, 1900+$year);
        close(SLOG);
    }
}

sub premain{
    if ($Debug >= 0){
        &debug_log("\$0: $0");
        &debug_log("EXECUTABLE_NAME: $^X") if defined $^X;
        &debug_log("OSNAME: $^O");
        &debug_log("PERL_VERSION: $]");
        &debug_log("pnamazu-2006.12.23");
        &debug_log("caller:" . join(", ", @caller));
        eval "use Cwd;";
        my $cwd = eval{&getcwd} unless $@;
        &debug_log("Cwd: $cwd") unless $@;
        my $key;
        for $key (@ARGV){
            &debug_log("ARGV: $key");
        }
        for $key (sort keys %ENV){
            &debug_log("Env: $key=$ENV{$key}");
        }
    }

    $Cgi = ($ENV{'GATEWAY_INTERFACE'} || !$CmdLineEna);
    $Xht = '';
    $Replace = $LOGGING = 1;
    $PageIndex = $PrintForm = $Cgi;
    $PlainConv = $DecodeURL = !$Cgi;
    $EmTagS = '<strong class="keyword">';
    $EmTagE = '</strong>';

    &config;

    if ($Cgi){
        if ($PhoneEnable eq 'always'
            or $PhoneEnable eq 'auto'
            && ($ENV{'HTTP_USER_AGENT'} =~ /docomo/i
                || $ENV{'HTTP_ACCEPT'} =~ /hdml/i
                || $ENV{'HTTP_X_JPHONE_MSNAME'})){
            $Phone = 1;
        }
        &load_namazu_conf;
        &cgiparamget;
    }else{
        &command_line_opt;
        &load_namazu_conf;
    }
    &set_nkf;

    &lang($CnfLang, $CmdLang);
    &set_output_ja_code('Shift_JIS') if $Phone;
    &debug_log(sprintf("%s, %s, %s", &get_language,
                       &get_output_ja_code, &get_input_ja_code,));

    if ($MakeGrep eq 'default'){
        $MakeGrep = ($GrepMode eq 'off')? '': 'g';
    }elsif ($MakeGrep eq 'option'){
        $MakeGrep = ($GrepMode eq 'on')? 'g': '';
    }else{
        $MakeGrep = '';
    }
}

sub main{
    my $language = &get_language;

    %Text = ('results' => 'Results',
             'word' => 'Word count',
             'total' => 'Total',
             'doc' => 'documents match your query.',
             'cgiwrap' => 'Please set SCRIPT_NAME',
            );
    if ($language =~ /ja|jp|jis/i){
        my $key;
        $Text{'results'} = '';
        $Text{'word'} = 'ͥҥåȿ';
        $Text{'total'} = '˥ޥå';
        $Text{'doc'} = 'ĤιܤĤޤ';
        $Text{'cgiwrap'} = 'SCRIPT_NAME ꤷƤ';
        for $key (keys %Text){
            $Text{$key} = &str2euc($Text{$key});
        }
    }
    $Text{'hit'} = 'Too many documents hit.  Ignored';
    $Text{'match'} = 'Too many words match.  Ignored';

    $IniPri = eval{getpriority(0, 0)};
    $SIG{'ALRM'} = \&alrm, eval{alarm $ReniceTime} if $Cgi && $ReniceTime > 0 && $RenicePri && !$^P;

    $DEFAULT_DIR .= '/' if $DEFAULT_DIR && $DEFAULT_DIR !~ /\/$/;

    if (@DbEnable){
        my(@tmp);
        for $tmp (@DbList){
            push(@tmp, $tmp) if grep {$tmp eq $_} @DbEnable;
        }
        @DbList = @tmp;
    }

    push(@DbList, undef) unless @DbList;
    $DbPath = &openfiles('', '') if @DbList > 1;
    $DbPath = &openfiles('', '', @DbList) unless $DbPath;

    &puthtmlheader;

    &disp_error;
    if (($OrigARGV = $ARGV) =~ /\S/){
        my $origIntType = $IntType;
        for $dblist (@DbList){
            $ARGV = $OrigARGV;
            $IntType = $origIntType;
            $DbList = &db_alias($dblist);
            $DbPath = &openfiles('', 'i', $DbList);
            &pre_proc;
            &searchmain;
            &slog if $LOGGING;
            &calc_slist($dblist);

            &disp_error;
            &closedb($DbPath);

            $RespARGV = $ARGV unless length $RespARGV;
            $RespTextOrig = 1 if $RespARGV ne $ARGV;
        }
        $ARGV = $OrigARGV if $RespTextOrig;
        $SList = "<ul>\n$SList\n</ul>\n" if $SList =~ /^\<li\>/;
        &searchsort;
        &headcat($Phone && $Keys) if !$PlainConv;

        &disp_error;

        local(*FORMAT);
        if ($LuckyURI){
        }elsif ($Cgi and !$Phone
                and (&openfiles(*FORMAT, 'format')
                     || &openfiles(*FORMAT, 'format', @DbList))){
            &format_init;
            &format(*FORMAT);
            close FORMAT;
        }else{
            my($a, $b) = ($Whence + 1, $Whence + $Max);
            $b = $Keys if ($b > $Keys || !$Max);

            if ($Cgi || $Format ne 'veryshort' and !$Quiet){
                if ($Phone){
                    if ($Keys){
                        &output("<p>Results $a - $b of $Keys</p>\n");
                    }else{
                        &output("<p>Not found.</p>\n");
                    }
                }else{
                    if ($Reference !~ /^off$/i){
                        &output("<h2>$Text{'results'}:</h2>\n");
                        &output("<p>\n<strong>$Text{'word'}:</strong></p>\n");
                        &output($SList);
                    }
                    &output("<p><strong>$Text{'total'} <!-- HIT -->$Keys<!-- HIT --> $Text{'doc'}</strong></p>\n");
                }
            }
            &puthlist;

            &output("<p>") if $PageIndex;
            if ($Keys && !$Phone && $Format ne 'veryshort' && !$Quiet){
                &output("<strong>Current List: $a - $b</strong><br$Xht>\n");
            }
            &putpageindex, &output("</p>") if $PageIndex;
        }
    }elsif (!$PlainConv){
        &headcat(0);
        if (!$Phone and 
            &opentfile(*FH, "$DbPath.body") || &openfiles(*FH, 'body')){
            &message(<FH>);
            close(FH);
        }
    }
    # NMZ.foot ν
    if (!$PlainConv && !$LuckyURI){
        if ($Phone){
            &output("</body></html>\n");
        }elsif (@FOOT){
            &message(@FOOT);
        }
    }
    &disp_debug;
}

sub alrm{
    &prn("<br$Xht>\n<hr>\nProcessing time exceeds a limit.\n"), exit if $RenicePri < 0;
    eval {setpriority(0, 0, $IniPri + $RenicePri);};
}

sub db_alias{
    my $db = shift;
    return undef unless defined $db;
    return $DbAlias{$db} if defined $DbAlias{$db};
    return $db;
}

&main;
&prn_flash;
1;
#----------------------- End of 'main' Module ------------------------
